#ifndef COURSE_H_
#define COURSE_H_ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

#include "Professor.h"
#include "Student.h"

using namespace std;

class Course
{
  private:
      char *code;
      Professor *prof;
      vector<Student *> students;
      
      void printStudents() {
	 int tS = students.size();
	 
	 for (int i=0; i<tS; i++) {
	    printf(" - %s\n", students[i]->getName());	   
	 }
      }
      
  public:
      
     Course(const char *pcode, const char *pname) {
	  code = new char[strlen(pcode)+1];
	  strcpy(code, pcode);

	  prof = new Professor(pname);
     }
            
     ~Course() {
	  delete[] code; // foram alocados varios char
	  delete prof;// foi alocado apenas 1 obj professor
	  
	  int tS = students.size();
	  for (int i=0; i<tS; i++) {
	     delete students[i];
	  }
	  students.clear();
     }
     
     void addStudent(Student *pstudent) {
        students.push_back(pstudent);
     }
      
     void printCourse() {
	  printf("\n%s, Professor: %s\n",
		 code, prof->getName());
          printStudents(); 
     }

};

#endif